class Button
{
  // Dumb button:
  // Raises public flag when clicked.
  // Uses public boolean for on-state

  public boolean clickedFlag;
  public boolean selected;

  int _x;
  int _y;
  int _thumbSize;
  
  float _boxx;
  float _boxy;
  
  boolean _mouseDown;
  boolean _mouseDownWas;
  boolean _isOver;
  

  Button(int $x, int $y, int $thumbSize)
  {
    _x = $x;
    _y = $y;
    _thumbSize = $thumbSize;
  }

  public void update()
  {
    _isOver = (mouseX >= _x && mouseX <= _x + _thumbSize &&
              mouseY >= _y && mouseY <= _y + _thumbSize);
    _mouseDownWas = _mouseDown;
    _mouseDown = mousePressed;
   
    if (_isOver && _mouseDown && !_mouseDownWas) 
      clickedFlag = true;
      // (let client detect flag and then clear it)
      
    draw();
  }
  
  private void draw()
  {
    stroke(96,96,96, 128);
    
    if (selected)
      fill(255,255,255, 192);
    else if (_isOver)
      fill(255,255,255, 128);
    else
      fill(255,255,255, 64);
  
    rect( _x, _y, _thumbSize, _thumbSize );
  }
}
