class MazeView2D implements IMazeView
{
  color _strokeColor = color(255);

  Maze _maze;
  float _unit = 30;
  
  MazeView2D()
  {
  }
  
  public void setMaze(Maze m)
  {
    _maze = m;
  }
  
  public float getUnitSize()
  {
    return _unit;
  }
  
  public void setUnitSize(float f)
  {
    _unit = f;
  }
  
  public void drawIt()
  {
    stroke(_strokeColor);
    strokeWeight(1);
    
    // vertical slats
    for (int x = 0; x < _maze.getWidth(); x++)
    {
      for (int y = 0; y < _maze.getHeight() - 1; y++)
      {
        if (_maze.getWallV(x,y))
        {
          line(x*_unit, y*_unit, x*_unit, (y+1)*_unit);
        }
      }
    }
    
    // horiz slats
    for (int y = 0; y < _maze.getHeight(); y++)
    {
      for (int x = 0; x < _maze.getWidth() - 1; x++)
      {
        if (_maze.getWallH(y,x))
        {
          line(x*_unit, y*_unit, (x+1)*_unit, y*_unit);
        }
      }
    }
  }
}
